Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Creators/ProbabilisticTreeCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Creators/ProbabilisticTreeCreator.cs	(revision 3359)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Creators/ProbabilisticTreeCreator.cs	(revision 3360)
@@ -29,4 +29,5 @@
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols;
 using System.Text;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ArchitectureAlteringOperators;
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
@@ -51,19 +52,6 @@
       int maxFunctionDefinitions, int maxFunctionArguments
       ) {
-      // tree size is limited by the grammar and by the explicit size constraints
-      int allowedMinSize = grammar.GetMinExpressionLength(grammar.StartSymbol);
-      int allowedMaxSize = Math.Min(maxTreeSize, grammar.GetMaxExpressionLength(grammar.StartSymbol));
-      // select a target tree size uniformly in the possible range (as determined by explicit limits and limits of the grammar)
-      int treeSize = random.Next(allowedMinSize, allowedMaxSize);
       SymbolicExpressionTree tree = new SymbolicExpressionTree();
-      do {
-        try {
-          tree.Root = PTC2(random, grammar, grammar.StartSymbol, treeSize + 1, maxTreeHeight + 1, maxFunctionDefinitions, maxFunctionArguments);
-        }
-        catch (ArgumentException) {
-          // try a different size
-          treeSize = random.Next(allowedMinSize, allowedMaxSize);
-        }
-      } while (tree.Root == null || tree.Size > maxTreeSize || tree.Height > maxTreeHeight);
+      tree.Root = PTC2(random, grammar, grammar.StartSymbol, maxTreeSize, maxTreeHeight, maxFunctionDefinitions, maxFunctionArguments);
       return tree;
     }
@@ -74,10 +62,37 @@
       public int ExtensionPointDepth { get; set; }
     }
+
+    /// <summary>
+    /// Creates a random tree with <paramref name="maxTreeSize"/> and <paramref name="maxDepth"/>.
+    /// </summary>
+    /// <param name="random"></param>
+    /// <param name="grammar"></param>
+    /// <param name="rootSymbol"></param>
+    /// <param name="maxTreeSize"></param>
+    /// <param name="maxDepth"></param>
+    /// <param name="maxFunctionDefinitions"></param>
+    /// <param name="maxFunctionArguments"></param>
+    /// <returns></returns>
     public static SymbolicExpressionTreeNode PTC2(IRandom random, ISymbolicExpressionGrammar grammar, Symbol rootSymbol,
-      int size, int maxDepth, int maxFunctionDefinitions, int maxFunctionArguments) {
-      SymbolicExpressionTreeNode root = rootSymbol.CreateTreeNode();
-      root.Grammar = grammar;
-      if (size <= 1 || maxDepth <= 1) return root;
-      CreateFullTreeFromSeed(random, root, size, maxDepth, maxFunctionDefinitions, maxFunctionArguments);
+      int maxTreeSize, int maxDepth, int maxFunctionDefinitions, int maxFunctionArguments) {
+      // tree size is limited by the grammar and by the explicit size constraints
+      int allowedMinSize = grammar.GetMinExpressionLength(rootSymbol);
+      int allowedMaxSize = Math.Min(maxTreeSize, grammar.GetMaxExpressionLength(rootSymbol));
+      // select a target tree size uniformly in the possible range (as determined by explicit limits and limits of the grammar)
+      int treeSize = random.Next(allowedMinSize, allowedMaxSize + 1);
+      SymbolicExpressionTreeNode root = null;
+      do {
+        try {
+          root = rootSymbol.CreateTreeNode();
+          root.Grammar = grammar;
+          if (treeSize <= 1 || maxDepth <= 1) return root;
+          CreateFullTreeFromSeed(random, root, treeSize, maxDepth, maxFunctionDefinitions, maxFunctionArguments);
+        }
+        catch (ArgumentException) {
+          // try a different size
+          root = null;
+          treeSize = random.Next(allowedMinSize, allowedMaxSize);
+        }
+      } while (root == null || root.GetSize() > maxTreeSize || root.GetHeight() > maxDepth);
       return root;
     }
@@ -105,12 +120,4 @@
         if (extensionDepth + parent.Grammar.GetMinExpressionDepth(parent.Symbol) >= maxDepth) {
           ReplaceWithMinimalTree(random, root, parent, argumentIndex, maxFunctionDefinitions, maxFunctionArguments);
-          //parent.RemoveSubTree(argumentIndex);
-          //var allowedSymbols = from s in parent.Grammar.Symbols
-          //                     where parent.Grammar.IsAllowedChild(parent.Symbol, s, argumentIndex)
-          //                     select s;
-          //SymbolicExpressionTreeNode branch = CreateMinimalTree(random, parent, allowedSymbols);
-          //parent.InsertSubTree(argumentIndex, branch); // insert a smallest possible tree
-          //currentSize += branch.GetSize();
-          //totalListMinSize -= branch.GetSize();
         } else {
           var allowedSymbols = from s in parent.Grammar.Symbols
@@ -118,8 +125,4 @@
                                where parent.Grammar.GetMinExpressionDepth(s) + extensionDepth - 1 < maxDepth
                                where parent.Grammar.GetMaxExpressionLength(s) > size - totalListMinSize - currentSize
-                               /*||
-                                     totalListMinSize + currentSize >= size * 0.9 // if the necessary size is almost reached then also allow
-                               // terminals or terminal-branches*/
-                               // where !IsDynamicSymbol(s) || IsDynamicSymbolAllowed(grammar, root, parent, s)
                                select s;
           Symbol selectedSymbol = SelectRandomSymbol(random, allowedSymbols);
@@ -172,15 +175,25 @@
         var dummy = new SymbolicExpressionTreeNode();
         tree.AddSubTree(dummy);
-        dummy.Grammar = (ISymbolicExpressionGrammar)dummy.Grammar.Clone(); 
+        dummy.Grammar = (ISymbolicExpressionGrammar)dummy.Grammar.Clone();
         // replace the just inserted dummy by recursive application
         ReplaceWithMinimalTree(random, root, tree, i, maxFunctionDefinitions, maxFunctionArguments);
       }
     }
-   
+
     private static void InitializeNewTreeNode(IRandom random, SymbolicExpressionTreeNode root, SymbolicExpressionTreeNode newTree, int maxFunctionDefinitions, int maxFunctionArguments) {
       // NB it is assumed that defuns are only allowed as children of root and nowhere else
       // also assumes that newTree is already attached to root somewhere
-      if (IsTopLevelBranch(root, newTree))
+      if (IsTopLevelBranch(root, newTree)) {
         newTree.Grammar = (ISymbolicExpressionGrammar)newTree.Grammar.Clone();
+
+        // allow invokes of existing ADFs with higher index
+        int argIndex = root.SubTrees.IndexOf(newTree);
+        for (int i = argIndex + 1; i < root.SubTrees.Count; i++) {
+          var otherDefunNode = root.SubTrees[i] as DefunTreeNode;
+          if (otherDefunNode != null) {
+            GrammarModifier.AddDynamicSymbol(newTree.Grammar, newTree.Symbol, otherDefunNode.FunctionName, otherDefunNode.NumberOfArguments);
+          }
+        }
+      }
       if (newTree.Symbol is Defun) {
         var defunTree = newTree as DefunTreeNode;
@@ -197,62 +210,15 @@
         defunTree.NumberOfArguments = nArgs;
         if (nArgs > 0) {
-          AddDynamicArguments(defunTree.Grammar, nArgs);
-        }
+          GrammarModifier.AddDynamicArguments(defunTree.Grammar, defunTree.Symbol, Enumerable.Range(0, nArgs));
+        }
+        // in existing branches with smaller index allow invoke of current function
         int argIndex = root.SubTrees.IndexOf(newTree);
-        // allow invokes of ADFs with higher index
-        for (int i = argIndex + 1; i < root.SubTrees.Count; i++) {
-          var otherDefunNode = root.SubTrees[i] as DefunTreeNode;
-          if (otherDefunNode != null) {
-            var allowedParents = from sym in defunTree.Grammar.Symbols
-                                 where defunTree.Grammar.IsAllowedChild(defunTree.Symbol, sym, 0)
-                                 select sym;
-            var allowedChildren = allowedParents;
-            AddDynamicSymbol(defunTree.Grammar, allowedParents, allowedChildren, otherDefunNode.FunctionName, otherDefunNode.NumberOfArguments);
-          }
-        }
-        // make the ADF available as symbol for other branches (with smaller index to prevent recursions)
         for (int i = 0; i < argIndex; i++) {
           // if not dummy node
           if (root.SubTrees[i].Symbol != null) {
-            var topLevelGrammar = root.SubTrees[i].Grammar;
-            var allowedParents = from sym in root.SubTrees[i].Grammar.Symbols
-                                 where root.SubTrees[i].Grammar.IsAllowedChild(root.SubTrees[i].Symbol, sym, 0)
-                                 select sym;
-            var allowedChildren = allowedParents;
-
-            AddDynamicSymbol(topLevelGrammar, allowedParents, allowedChildren, functionName, nArgs);
+            var existingBranch = root.SubTrees[i];
+            GrammarModifier.AddDynamicSymbol(existingBranch.Grammar, existingBranch.Symbol, functionName, nArgs);
           }
         }
-      }
-    }
-
-    private static void AddDynamicSymbol(ISymbolicExpressionGrammar grammar, IEnumerable<Symbol> allowedParents, IEnumerable<Symbol> allowedChildren, string symbolName, int nArgs) {
-      var invokeSym = new InvokeFunction(symbolName);
-      grammar.AddSymbol(invokeSym);
-      grammar.SetMinSubtreeCount(invokeSym, nArgs);
-      grammar.SetMaxSubtreeCount(invokeSym, nArgs);
-      foreach (var parent in allowedParents) {
-        for (int arg = 0; arg < grammar.GetMaxSubtreeCount(parent); arg++) {
-          grammar.SetAllowedChild(parent, invokeSym, arg);
-        }
-      }
-      foreach (var child in allowedChildren) {
-        for (int arg = 0; arg < grammar.GetMaxSubtreeCount(invokeSym); arg++) {
-          grammar.SetAllowedChild(invokeSym, child, arg);
-        }
-      }
-    }
-
-    private static void AddDynamicArguments(ISymbolicExpressionGrammar grammar, int nArgs) {
-      for (int argIndex = 0; argIndex < nArgs; argIndex++) {
-        var argNode = new Argument(argIndex);
-        grammar.AddSymbol(argNode);
-        grammar.SetMinSubtreeCount(argNode, 0);
-        grammar.SetMaxSubtreeCount(argNode, 0);
-        // allow the argument as child of any other symbol
-        foreach (var symb in grammar.Symbols)
-          for (int i = 0; i < grammar.GetMaxSubtreeCount(symb); i++) {
-            grammar.SetAllowedChild(symb, argNode, i);
-          }
       }
     }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/DefaultSymbolicExpressionGrammar.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/DefaultSymbolicExpressionGrammar.cs	(revision 3359)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/DefaultSymbolicExpressionGrammar.cs	(revision 3360)
@@ -81,4 +81,9 @@
 
     public void RemoveSymbol(Symbol symbol) {
+      foreach (var parent in Symbols) {
+        for (int i = 0; i < GetMaxSubtreeCount(parent); i++)
+          if (IsAllowedChild(parent, symbol, i))
+            allowedChildSymbols[parent.Name][i].Remove(symbol.Name);
+      }
       allSymbols.RemoveWhere(s => s.Name == symbol.Name);
       minSubTreeCount.Remove(symbol.Name);
@@ -208,5 +213,11 @@
       clone.minSubTreeCount = new Dictionary<string, int>(minSubTreeCount);
       clone.startSymbol = startSymbol;
-      clone.allowedChildSymbols = new Dictionary<string, List<HashSet<string>>>(allowedChildSymbols);
+      clone.allowedChildSymbols = new Dictionary<string, List<HashSet<string>>>();
+      foreach (var entry in allowedChildSymbols) {
+        clone.allowedChildSymbols[entry.Key] = new List<HashSet<string>>();
+        foreach (var set in entry.Value) {
+          clone.allowedChildSymbols[entry.Key].Add(new HashSet<string>(set));
+        }
+      }
       clone.allSymbols = new HashSet<Symbol>(allSymbols);
       return clone;
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/GlobalSymbolicExpressionGrammar.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/GlobalSymbolicExpressionGrammar.cs	(revision 3359)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/GlobalSymbolicExpressionGrammar.cs	(revision 3360)
@@ -82,5 +82,5 @@
     }
 
-    private void Reset() {
+    private new void Reset() {
       base.Reset();
       Initialize();
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.csproj	(revision 3359)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.3.csproj	(revision 3360)
@@ -85,4 +85,13 @@
     <Compile Include="ArchitectureAlteringOperators\ArgumentCreater.cs" />
     <Compile Include="ArchitectureAlteringOperators\ArgumentDeleter.cs" />
+    <Compile Include="ArchitectureAlteringOperators\ArgumentDuplicater.cs" />
+    <Compile Include="ArchitectureAlteringOperators\GrammarModifier.cs" />
+    <Compile Include="ArchitectureAlteringOperators\RandomArchitectureAlteringOperator.cs" />
+    <Compile Include="ArchitectureAlteringOperators\SubroutineCreater.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="ArchitectureAlteringOperators\SubroutineDeleter.cs" />
+    <Compile Include="ArchitectureAlteringOperators\SubroutineDuplicater.cs" />
+    <Compile Include="SymbolicExpressionTreeTopLevelNode.cs" />
     <Compile Include="Crossovers\SubtreeCrossover.cs">
       <SubType>Code</SubType>
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTree.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTree.cs	(revision 3359)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTree.cs	(revision 3360)
@@ -77,11 +77,4 @@
     }
 
-    public SymbolicExpressionTreeNode GetTopLevelBranchOf(SymbolicExpressionTreeNode node) {
-      foreach (var branch in root.SubTrees) {
-        if (branch.IterateNodesPrefix().Contains(node)) return branch;
-      }
-      throw new ArgumentException("Node was not found in tree.");
-    }
-
     public override IDeepCloneable Clone(Cloner cloner) {
       SymbolicExpressionTree clone = new SymbolicExpressionTree();
@@ -91,11 +84,4 @@
       return clone;
     }
-
-    public bool IsValidExpression() {
-      if (root.Symbol != root.Grammar.StartSymbol) return false;
-      foreach (var subtree in root.SubTrees)
-        if (subtree.Grammar == root.Grammar) return false;
-      return root.IsValidTree();
-    }
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeNode.cs	(revision 3359)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeNode.cs	(revision 3360)
@@ -128,13 +128,4 @@
       yield return this;
     }
-    //public int GetMinExpressionLength() {
-    //  return Grammar.GetMinExpressionLength(Symbol);
-    //}
-    //public int GetMaxExpressionLength() {
-    //  return Grammar.GetMaxExpressionLength(Symbol);
-    //}
-    //public int GetMinExpressionDepth() {
-    //  return Grammar.GetMinExpressionDepth(Symbol);
-    //}
     public IEnumerable<Symbol> GetAllowedSymbols(int argumentIndex) {
       return Grammar.Symbols.Where(s => Grammar.IsAllowedChild(Symbol, s, argumentIndex));
@@ -146,13 +137,4 @@
       return Grammar.GetMaxSubtreeCount(Symbol);
     }
-    //public int GetMaxExpressionLength(Symbol s) {
-    //  return Grammar.GetMaxExpressionLength(s);
-    //}
-    //public int GetMinExpressionLength(Symbol s) {
-    //  return Grammar.GetMinExpressionLength(s);
-    //}
-    //public int GetMinExpressionDepth(Symbol s) {
-    //  return Grammar.GetMinExpressionDepth(s);
-    //}
 
     #region ICloneable Members
@@ -165,17 +147,5 @@
 
 
-    public bool IsValidTree() {
-      var matchingSymbol = (from symb in Grammar.Symbols
-                            where symb.Name == Symbol.Name
-                            select symb).SingleOrDefault();
 
-      if (SubTrees.Count < Grammar.GetMinSubtreeCount(matchingSymbol)) return false;
-      else if (SubTrees.Count > Grammar.GetMaxSubtreeCount(matchingSymbol)) return false;
-      else for (int i = 0; i < SubTrees.Count; i++) {
-          if (!GetAllowedSymbols(i).Select(x => x.Name).Contains(SubTrees[i].Symbol.Name)) return false;
-          if (!SubTrees[i].IsValidTree()) return false;
-        }
-      return true;
-    }
   }
 }
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeTopLevelNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeTopLevelNode.cs	(revision 3360)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTreeTopLevelNode.cs	(revision 3360)
@@ -0,0 +1,54 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using System.Xml;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Data;
+using System.Diagnostics;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
+  [StorableClass]
+  public class SymbolicExpressionTreeTopLevelNode : SymbolicExpressionTreeNode {
+
+    public SymbolicExpressionTreeTopLevelNode()
+      : base() {
+    }
+
+    public SymbolicExpressionTreeTopLevelNode(Symbol symbol)
+      : base(symbol) {
+    }
+
+    // copy constructor
+    protected SymbolicExpressionTreeTopLevelNode(SymbolicExpressionTreeTopLevelNode original)
+      : base(original) {
+      Grammar = (ISymbolicExpressionGrammar)original.Grammar.Clone();
+    }
+
+    public override object Clone() {
+      return new SymbolicExpressionTreeTopLevelNode(this);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/DefunTreeNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/DefunTreeNode.cs	(revision 3359)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/DefunTreeNode.cs	(revision 3360)
@@ -25,5 +25,5 @@
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols {
   [StorableClass]
-  public sealed class DefunTreeNode : SymbolicExpressionTreeNode {
+  public sealed class DefunTreeNode : SymbolicExpressionTreeTopLevelNode {
     private int numberOfArguments;
     [Storable]
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/InvokeFunctionTreeNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/InvokeFunctionTreeNode.cs	(revision 3359)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/InvokeFunctionTreeNode.cs	(revision 3360)
@@ -27,4 +27,9 @@
     public new InvokeFunction Symbol {
       get { return (InvokeFunction)base.Symbol; }
+      set {
+        if (value == null) throw new ArgumentNullException();
+        if (!(value is InvokeFunction)) throw new ArgumentNullException();
+        base.Symbol = value;
+      }
     }
 
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/StartSymbolTreeNode.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/StartSymbolTreeNode.cs	(revision 3359)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Symbols/StartSymbolTreeNode.cs	(revision 3360)
@@ -24,5 +24,5 @@
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.GeneralSymbols {
   [StorableClass]
-  public sealed class StartSymbolTreeNode : SymbolicExpressionTreeNode {
+  public sealed class StartSymbolTreeNode : SymbolicExpressionTreeTopLevelNode {
     // copy constructor
     private StartSymbolTreeNode(StartSymbolTreeNode original)
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/AllArchitectureAlteringOperatorsTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/AllArchitectureAlteringOperatorsTest.cs	(revision 3360)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/AllArchitectureAlteringOperatorsTest.cs	(revision 3360)
@@ -0,0 +1,98 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Text;
+using System.Collections.Generic;
+using System.Linq;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Random;
+using System.Diagnostics;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ArchitectureAlteringOperators;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_3._3.Tests {
+  [TestClass]
+  public class AllArchitectureAlteringOperatorsTest {
+    private const int POPULATION_SIZE = 1000;
+    private const int N_ITERATIONS = 20;
+    private const int MAX_TREE_SIZE = 100;
+    private const int MAX_TREE_HEIGHT = 10;
+    private TestContext testContextInstance;
+
+    /// <summary>
+    ///Gets or sets the test context which provides
+    ///information about and functionality for the current test run.
+    ///</summary>
+    public TestContext TestContext {
+      get {
+        return testContextInstance;
+      }
+      set {
+        testContextInstance = value;
+      }
+    }
+
+    [TestMethod()]
+    public void AllArchitectureAlteringOperatorsDistributionTest() {
+      var trees = new List<SymbolicExpressionTree>();
+      var newTrees = new List<SymbolicExpressionTree>();
+      var grammar = Grammars.CreateArithmeticAndAdfGrammar();
+      var random = new MersenneTwister(31415);
+      int failedEvents = 0;
+      IntValue maxTreeSize = new IntValue(100);
+      IntValue maxTreeHeigth = new IntValue(10);
+      IntValue maxDefuns = new IntValue(3);
+      IntValue maxArgs = new IntValue(3);
+      for (int i = 0; i < POPULATION_SIZE; i++) {
+        var tree = ProbabilisticTreeCreator.Create(random, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3);
+        Util.IsValid(tree);
+        trees.Add(tree);
+      }
+      Stopwatch stopwatch = new Stopwatch();
+      stopwatch.Start();
+      var combinedAAOperator = new RandomArchitectureAlteringOperator();
+      for (int g = 0; g < N_ITERATIONS; g++) {
+        for (int i = 0; i < POPULATION_SIZE; i++) {
+          var selectedTree = (SymbolicExpressionTree)trees.SelectRandom(random).Clone();
+          var op = combinedAAOperator.Operators.SelectRandom(random);
+          bool success;
+          op.ModifyArchitecture(random, selectedTree, grammar, maxTreeSize, maxTreeHeigth, maxDefuns, maxArgs, out success);
+          if (!success) failedEvents++;
+          Util.IsValid(selectedTree);
+          newTrees.Add(selectedTree);
+        }
+        trees = newTrees;
+      }
+      stopwatch.Stop();
+      var msPerOperation = stopwatch.ElapsedMilliseconds / (double)POPULATION_SIZE / (double)N_ITERATIONS;
+      Assert.Inconclusive("AllArchitectureAlteringOperators: " + Environment.NewLine +
+        "Failed events: " + failedEvents / (double)POPULATION_SIZE / N_ITERATIONS * 100 + " %" + Environment.NewLine +
+        "Operations / s: ~" + Math.Round(1000.0 / (msPerOperation)) + "operations / s)" + Environment.NewLine +
+        Util.GetSizeDistributionString(trees, 200, 5) + Environment.NewLine +
+        Util.GetFunctionDistributionString(trees) + Environment.NewLine +
+        Util.GetNumberOfSubTreesDistributionString(trees) + Environment.NewLine +
+        Util.GetTerminalDistributionString(trees) + Environment.NewLine
+        );
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentCreaterTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentCreaterTest.cs	(revision 3359)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentCreaterTest.cs	(revision 3360)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Text;
 using System.Collections.Generic;
@@ -34,13 +55,16 @@
       var trees = new List<SymbolicExpressionTree>();
       var grammar = Grammars.CreateArithmeticAndAdfGrammar();
-      var random = new MersenneTwister();
+      var random = new MersenneTwister(31415);
+      int failedEvents = 0;
       for (int i = 0; i < POPULATION_SIZE; i++) {
         var tree = ProbabilisticTreeCreator.Create(random, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3);
-        ArgumentCreater.CreateNewArgument(random, tree, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3);
-        Assert.IsTrue(tree.IsValidExpression());
+        if (!ArgumentCreater.CreateNewArgument(random, tree, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3))
+          failedEvents++;
+        Util.IsValid(tree);
         trees.Add(tree);
       }
       Assert.Inconclusive("ArgumentCreator: " + Environment.NewLine +
-        Util.GetSizeDistributionString(trees, 105, 5) + Environment.NewLine +
+        "Failed events: " + failedEvents / (double)POPULATION_SIZE * 100 + " %" + Environment.NewLine +
+        Util.GetSizeDistributionString(trees, 200, 20) + Environment.NewLine +
         Util.GetFunctionDistributionString(trees) + Environment.NewLine +
         Util.GetNumberOfSubTreesDistributionString(trees) + Environment.NewLine +
Index: /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentDeleterTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentDeleterTest.cs	(revision 3359)
+++ /trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/Tests/ArgumentDeleterTest.cs	(revision 3360)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Text;
 using System.Collections.Generic;
@@ -34,12 +55,15 @@
       var trees = new List<SymbolicExpressionTree>();
       var grammar = Grammars.CreateArithmeticAndAdfGrammar();
-      var random = new MersenneTwister();
+      var random = new MersenneTwister(31415);
+      int failedEvents = 0;
       for (int i = 0; i < POPULATION_SIZE; i++) {
         var tree = ProbabilisticTreeCreator.Create(random, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3);
-        ArgumentDeleter.DeleteArgument(random, tree, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3);
-        Assert.IsTrue(tree.IsValidExpression());
+        if (!ArgumentDeleter.DeleteArgument(random, tree, grammar, MAX_TREE_SIZE, MAX_TREE_HEIGHT, 3, 3))
+          failedEvents++;
+        Util.IsValid(tree);
         trees.Add(tree);
       }
       Assert.Inconclusive("ArgumentDeleter: " + Environment.NewLine +
+        "Failed events: " + failedEvents / (double)POPULATION_SIZE * 100 + " %" + Environment.NewLine +
         Util.GetSizeDistributionString(trees, 105, 5) + Environment.NewLine +
         Util.GetFunctionDistributionString(trees) + Environment.NewLine +
